const util = require('../utils/util.js')
/**
 * 本API中全部用于 我的学分等 相关接口 
 */

/* 获取我的学分信息 */
const getMyScore = (callback) => {
  util.requestApi({
    url: util.config.URL_PATH1 + '/v2/education/credits',
    callback: function (res) {
      let _data = res.data
      let json = {
        raw: _data,
        total: _data.total_credits,
        myTotal: _data.my_total_credits,
        myTotalStr: _data.total_credits && ((_data.my_total_credits * 1.0 / _data.total_credits * 100).toFixed(1) + '%') || '0%',
        must: _data.required_credits,
        myMust: _data.my_required_credits,
        myMustStr: _data.required_credits && ((_data.my_required_credits * 1.0 / _data.required_credits * 100).toFixed(1) + '%') || '0%',
        unmust: _data.optional_credits,
        myUnmust: _data.my_optional_credits,
        myUnmustStr: _data.optional_credits && ((_data.my_optional_credits * 1.0 / _data.optional_credits * 100).toFixed(1) + '%') || '0%',
        lists: _data.lists
      }
      callback(json)
    }
  })
}
module.exports = {
  getMyScore: getMyScore
}